#include    <Windows.h>
#include    <stdio.h>
#include    "STDmacro.h"

#include    "Wmacros.h"
#include    "MTypes.h"
#include    "CBList.h"
/*######################################################################*/
double  CBList::Get()  
{ 
    if(m_bMax) 
        Cut(m_dData[m_nPos], m_dMin, m_dMax); 
    return m_dData[m_nPos]; 
}
/*----------------------------------------------------------------------*/
void    CBList::Init(int id, int pos) 
{ 
    m_nID = id; 
    SetI(pos);
    for(int i = 0; i < m_nData; ++i) 
        m_dData[i] = 0.0;
}
/*----------------------------------------------------------------------*/
void    MySprintf(char* str, char* fmt, double val)
{
    sprintf(str, fmt, val);
    int n = strlen(str) - 1;
    for(int i = n; i >= 0; --i)
        if(str[i] == '.')
        {
            for(; n >= i && (str[n] == '0' || str[n] == '.'); --n)
                str[n] = 0;
            break;
        }
}
/*----------------------------------------------------------------------*/
void    CBList::Fill(HWND hWnd) 
{
    CbReset(m_nID);
    SendDlgItemMessage(hWnd, m_nID, CB_LIMITTEXT, 20, 0);
    for(int i = 0; i < m_nData; ++i)
    {
        if(m_dData[i] < m_dMin) 
            m_dData[i] = m_dMin;
        else
        if(m_bMax && m_dData[i] > m_dMax) 
            m_dData[i] = m_dMax;
        char str[100];
        MySprintf(str, m_szFmt, m_dData[i]);
        CbAddString(m_nID, str);
    }
    CbSet(m_nID, m_nPos);
}
/*----------------------------------------------------------------------*/
void    CBList::GetEdit(HWND hWnd)
{
    char strI[50], strO[50];
    GetDlgItemText(hWnd, m_nID, strI, DIM(strI)-1);
    strI[DIM(strI)-1] = 0;
    double mul = 1.0;
    for(int i = 0, j = 0, f = 0, e = 0, ec = 0, em = 3; strI[i]; ++i)
    {
        char c = strI[i];
        if(strI[i+1] == 0)
        {
            if(c == 'K') 
            {
                mul = 1024.0; 
                break; 
            }
            if(c == 'M') 
            {
                mul = 1024.0*1024.0; 
                break; 
            }
        }
        if(!j && c == '-') 
            strO[j++] = c;
        if(ec < em && c >= '0' && c <= '9') 
            strO[j++] = c;
        if(j && !e)
        {
            if(c == 'D' || c == 'E') 
            {
                ++e;
                strO[j++] = c;
            }
            else
            if(!f && (c == '.' || c == ',')) 
            {
                ++f;
                strO[j++] = '.';
            }
        }
        else
        {
            if(ec == 0 && (c == '-' || c == '+')) 
                strO[j++] = c, ++em;
            ++ec;
        }
    }
    if(j > 22) 
        j = 22;
    strO[j] = 0;
    if(i != j) 
    {
        DWORD st = 0, ed = 0;
        SendDlgItemMessage(hWnd, m_nID, CB_GETEDITSEL, (unsigned)&st, (unsigned)&ed);
        SetDlgItemText(hWnd, m_nID, strO); 
        SendDlgItemMessage(hWnd, m_nID, CB_SETEDITSEL, 0, MAKELPARAM(st, st)/*MAKELPARAM(j, j)*/);
    }
    double d = atof(strO) * mul;
    i = 0;
    if(d < m_dEMin) 
        d = m_dEMin, i = 1;
    else
    if(m_bMax)
    {
        if(d > m_dMax) 
            d /= 10, i = 1;
        if(d > m_dMax) 
            d = m_dMax, i = 1;
    }
    if(m_dData[m_nPos] != d)
    m_dData[m_nPos] = d;
    if(i)
    {
        char str[100];
        MySprintf(str, m_szFmt, m_dData[m_nPos]);
        SetDlgItemText(hWnd, m_nID, str);
        SendDlgItemMessage(hWnd, m_nID, CB_SETEDITSEL, 0, MAKELPARAM(j, j));  
    }
}
/*----------------------------------------------------------------------*/
int     CBList::Proc(HWND hWnd, WPARAM w, LPARAM l)
{
    if(LOWORD(w) != m_nID) 
        return 0;
    int ret = 1;
    switch(HIWORD(w))
    {
    case CBN_EDITUPDATE:
        ret = 2;
        GetEdit(hWnd);
    break;
    case CBN_KILLFOCUS:
        l = 0;
    case CBN_CLOSEUP:
        {
            ret = 3;
            if(l != 0)
                SetI(CbGetIndex(m_nID));
            char str[100];
            if(m_dData[m_nPos] < m_dMin)
                m_dData[m_nPos] = m_dMin;
            else
            if(m_bMax && m_dData[m_nPos] > m_dMax) 
                m_dData[m_nPos] = m_dMax;
            MySprintf(str, m_szFmt, m_dData[m_nPos]);
            SendDlgItemMessage(hWnd, m_nID, CB_DELETESTRING, m_nPos, 0);
            SendDlgItemMessage(hWnd, m_nID, CB_INSERTSTRING, m_nPos, LONG(LPSTR(str)));
            CbSet(m_nID, m_nPos);
            int i = strlen(str);
            SendDlgItemMessage(hWnd, m_nID, CB_SETEDITSEL, 0, MAKELPARAM(i, i));  
        }
        break;
    case CBN_DROPDOWN:
        {
            ret = 4;
            char str[100];
            MySprintf(str, m_szFmt, m_dData[m_nPos]);
            SendDlgItemMessage(hWnd, m_nID, CB_DELETESTRING, m_nPos, 0);
            SendDlgItemMessage(hWnd, m_nID, CB_INSERTSTRING, m_nPos, LONG(LPSTR(str)));
            CbSet(m_nID, m_nPos);
            int i = strlen(str);
            SendDlgItemMessage(hWnd, m_nID, CB_SETEDITSEL, 0, MAKELPARAM(i, i));  
        }
        break;
    case CBN_SETFOCUS:
        break;
    }
    return ret;
}
/*######################################################################*/
