#ifndef __COMPLEXMAC_H__
#define __COMPLEXMAC_H__

#include    <math.h>

#include    "FFTInc.h"
/*######################################################################*/
#define cdef(name)          reall name##r, name##i
#define cdef1(name, orig)   reall name##r = orig##r, name##i = orig##i
#define cdef2(name, re, im) reall name##r = real(re), name##i = real(im)

#define cmov(a, b)          a##r = b##r,  a##i = b##i
#define cmov2(a, re, im)    a##r = real(re), a##i = real(im)

#define cneg(a)             a##r = -a##r, a##i = -a##i 
#define cconj(a)            a##i = -a##i 
//  a += b
#define cadd(a, b)          a##r += b##r, a##i += b##i
//  c = a + b
#define cadd2(c, a, b)      c##r = a##r + b##r, c##i = a##i + b##i
//  a -= b
#define csub(a, b)          a##r -= b##r, a##i -= b##i
//  c = a - b
#define csub2(c, a, b)      c##r = a##r - b##r, c##i = a##i - b##i
//  a *= b
#define cmul(a, b)                          \
{                                           \
    reall t = a##r*b##r - a##i*b##i;        \
       a##i = a##r*b##i + a##i*b##r;        \
       a##r = t;                            \
}
//  c = a * b
#define cmul2(c, a, b)                      \
{                                           \
    reall t = a##r*b##r - a##i*b##i;        \
      c##i  = a##r*b##i + a##i*b##r;        \
      c##r  = t;                            \
}
//  a /= b
#define cdiv(a, b)                          \
{                                           \
    reall q = 1/(b##r*b##r + b##i*b##i),    \
         t  = (a##r*b##r + a##i*b##i)*q;    \
      a##i  = (a##i*b##r - a##r*b##i)*q;    \
      a##r  = t;                            \
}
//  c = a / b
#define cdiv2(c, a, b)                      \
{                                           \
    reall q = 1/(b##r*b##r + b##i*b##i),    \
         t  = (a##r*b##r + a##i*b##i)*q;    \
      c##i  = (a##i*b##r - a##r*b##i)*q;    \
      c##r  = t;                            \
}
/*######################################################################*/
#endif
