/*######################################################################*/
// Designed and written by Andry Zharov
// Tel/Fax: (095)2057970
// Email:   zharov@postman.ru
/*######################################################################*/
#define pushR       __asm { __asm push ebp __asm push ebx __asm push esi __asm push edi }
#define popR        __asm { __asm pop  edi __asm pop  esi __asm pop  ebx __asm pop  ebp }
#define mySP(n)     (esp+16+4*n)
#define ret(n)      __asm ret n*4
/*######################################################################*/
__declspec(naked)
void __stdcall  FastCopy(void* src, void* dst, int cnt, int MMXflag)
{
    pushR;
    __asm
    {
        mov     edx,    [mySP(1)]   // src
        mov     ebx,    [mySP(2)]   // dst
        mov     ecx,    [mySP(3)]   // cnt
//-----------------------------------------------
        cmp     ecx,    100                     
        jb      tail                    
        test    edx,    3                       
        je      skipBLeader             
bLeaderLoop:                                    
        mov     al,     [edx]                   
        inc     edx                             
        mov     [ebx],  al                      
        dec     ecx                             
        test    edx,    3                       
        lea     ebx,    [ebx+1]                 
        jne     bLeaderLoop             
skipBLeader:                                    
        test    edx,    0x3C                    
        je      skipDLeader             
dLeaderLoop:                                    
        mov     eax,    [edx]                   
        add     edx,    4                       
        mov     [ebx],  eax                     
        sub     ecx,    4                       
        test    edx,    0x3C                     
        lea     ebx,    [ebx+4]                 
        jne     dLeaderLoop             
skipDLeader:                                    
        cmp     [mySP(4)],  0   // MMXflag
        jz      noMMX
//...............................................
        mov     eax,    edx                     
        mov     esi,    0x1000                   
        and     eax,    0x0FFF                   
        sub     esi,    eax                     
        sub     ecx,    esi                     
        mov     edi,    edx                     
        jb      lastPageX                
pageLoopX:                                       
touchLoopX:                                      
        mov     al,     [edi]                   
        mov     al,     [edi+32]                
        sub     esi,    64                      
        lea     edi,    [edi+64]                
        jne     touchLoopX               
        sub     edi,    edx                     
copyLoopX:
        movq    mm0,    [edx   ]                
        movq    mm4,    [edx+32]                
        movq    mm1,    [edx+ 8]                
        movq    mm5,    [edx+40]                
        movq    [ebx   ],       mm0             
        movq    [ebx+ 8],       mm1             
        movq    mm2,    [edx+16]                
        movq    mm6,    [edx+48]                
        movq    mm3,    [edx+24]                
        movq    mm7,    [edx+56]                
        movq    [ebx+16],       mm2             
        movq    [ebx+24],       mm3             
        movq    [ebx+32],       mm4             
        movq    [ebx+40],       mm5             
        movq    [ebx+48],       mm6             
        movq    [ebx+56],       mm7
        add     edx,    64                      
        sub     edi,    64                      
        lea     ebx,    [ebx+64]
        ja      copyLoopX                
        mov     esi,    0x1000                   
        sub     ecx,    0x1000                   
        mov     edi,    edx                     
        jae     pageLoopX                
lastPageX:                                       
        add     ecx,    esi                     
        mov     esi,    ecx                     
        and     ecx,    0x3F                     
        and     esi,    0x0FFFFFFC0              
        jne     pageLoopX
        emms
        jmp     tail
//...............................................
noMMX:
        mov     eax,    edx                     
        mov     esi,    0x1000                   
        and     eax,    0x0FFF                   
        sub     esi,    eax                     
        sub     ecx,    esi                     
        mov     edi,    edx                     
        jb      lastPage                
pageLoop:                                       
touchLoop:                                      
        mov     al,     [edi]                   
        mov     al,     [edi+32]                
        sub     esi,    64                      
        lea     edi,    [edi+64]                
        jne     touchLoop               
        sub     edi,    edx                     
copyLoop:                                       
        mov     eax,    [edx   ]                
        mov     esi,    [edx+32]                
        mov     [ebx   ],       eax             
        mov     [ebx+32],       esi             
        mov     eax,    [edx+ 4]                
        mov     esi,    [edx+36]                
        mov     [ebx+ 4],       eax             
        mov     [ebx+36],       esi             
        mov     eax,    [edx+ 8]                
        mov     esi,    [edx+40]                
        mov     [ebx+ 8],       eax             
        mov     [ebx+40],       esi             
        mov     eax,    [edx+12]                
        mov     esi,    [edx+44]                
        mov     [ebx+12],       eax             
        mov     [ebx+44],       esi             
        mov     eax,    [edx+16]                
        mov     esi,    [edx+48]                
        mov     [ebx+16],       eax             
        mov     [ebx+48],       esi             
        mov     eax,    [edx+20]                
        mov     esi,    [edx+52]                
        mov     [ebx+20],       eax             
        mov     [ebx+52],       esi             
        mov     eax,    [edx+24]                
        mov     esi,    [edx+56]                
        mov     [ebx+24],       eax             
        mov     [ebx+56],       esi             
        mov     eax,    [edx+28]                
        mov     esi,    [edx+60]                
        mov     [ebx+28],       eax             
        mov     [ebx+60],       esi             
        add     edx,    64                      
        sub     edi,    64                      
        lea     ebx,    [ebx+64]
        ja      copyLoop                
        mov     esi,    0x1000                   
        sub     ecx,    0x1000                   
        mov     edi,    edx                     
        jae     pageLoop                
lastPage:                                       
        add     ecx,    esi                     
        mov     esi,    ecx                     
        and     ecx,    0x3F                     
        and     esi,    0x0FFFFFFC0              
        jne     pageLoop                
//...............................................
tail:                                           
        cmp     ecx,    4                       
        jb      bTail                   
wTailLoop:                                      
        mov     eax,    [edx]                   
        add     edx,    4                       
        mov     [ebx],  eax                     
        sub     ecx,    4                       
        lea     ebx,    [ebx+4]                 
        cmp     ecx,    4                       
        ja      wTailLoop               
bTail:                                          
        test    ecx,    ecx                     
        je      finish                  
bTailLoop:                                      
        mov     al,     [edx]                   
        inc     edx                             
        mov     [ebx],  al                      
        dec     ecx                             
        lea     ebx,    [ebx+1]                 
        jne     bTailLoop               
//-----------------------------------------------
    }
finish:                                         
    popR;
    ret(4);
}
/*######################################################################*/
