#include    "IsMMX.h"
/*######################################################################*/
// By Andry Zharov
/*######################################################################*/
#ifndef __BORLAND_CPP__
#define CPUID       __asm _emit 00fh __asm _emit 0a2h
#define RDTSC       __asm _emit 00fh __asm _emit 031h
#define OPCODEIII   __asm _emit 00Fh __asm _emit 057h __asm _emit 0C0h
#else
#define CPUID       DB 00fh, 0a2h
#define RDTSC       DB 00fh, 031h
#define OPCODEIII   DB 00Fh, 057h, 0C0h
#endif
/*----------------------------------------------------------------------*/
__declspec(naked) 
unsigned __int64 __stdcall getRDTSC()
{
#ifdef  OLD_PENTIUM
    __asm 
    {
        push    ebx
        push    ecx
        xor     eax, eax
        CPUID
        RDTSC
        push    eax
        push    edx
        xor     eax, eax
        CPUID
        pop     edx
        pop     eax
        pop     ecx
        pop     ebx
        ret
    }
#else
    __asm 
    {
        RDTSC
        ret
    }
#endif
}
/*----------------------------------------------------------------------*/
static void cpuid(unsigned index, unsigned* abcd)
{
    __asm 
    {
        push    ebx
        push    ecx
        push    edx
        mov     eax,        index
        CPUID
        mov     edi,        abcd
        mov     [edi   ],   eax
        mov     [edi+ 4],   ebx
        mov     [edi+ 8],   ecx
        mov     [edi+12],   edx
        pop     edx
        pop     ecx
        pop     ebx
    }
}
/*----------------------------------------------------------------------*/
static int  isNotPentium()
{
    unsigned abcd[4];
    __asm
    {
        pushfd                          // read
        mov     eax,    [esp]           // PSW
        xor     eax,    0x200000        // change PSW
        push    eax                     // write
        popfd                           // changed PSW
        mov     edx,    eax
        pushfd                          // read
        pop     eax                     // again
        popfd                           // restore PSW
        sub     eax,    edx
        mov     [abcd], eax
    }
    if(abcd[0])     
        return 1;                       // old 486
    cpuid(0, abcd);
    if(abcd[0] < 1) 
        return 1;                       // not a Pentium
    return 0;                           // Pentium...
}
/*======================================================================*/
int __stdcall isMMX()
{
    if(isNotPentium()) 
        return 0;
    unsigned abcd[4];
    cpuid(1, abcd);
    return (abcd[3] & 0x800000) != 0;
}
/*----------------------------------------------------------------------*/
int __stdcall isProcType()
{
    if(isNotPentium()) 
        return 0;
    unsigned abcd[4];
    cpuid(1, abcd);
    return ((abcd[0]>>8) & 0xF);        // 5, 6, 7, ...
}
/*----------------------------------------------------------------------*/
int __stdcall isAMD3D()
{
    if(!isMMX()) 
        return 0;
    unsigned abcd[4];
    cpuid(0x80000000, abcd);
    if(abcd[0] == 0) 
        return 0;
    cpuid(0x80000001, abcd);
    return (abcd[3] & 0x80000000) != 0;
}
/*----------------------------------------------------------------------*/
#ifdef  _PIII_
int __stdcall isPIII()
{
    if(!isMMX()) 
        return 0;
    unsigned abcd[4];
    cpuid(1, abcd);
    if((abcd[3] & 0x02000000) == 0) 
        return 0;

#ifndef _VMM_
    try
    {
        __asm
        {
            OPCODEIII
        }
    }
    catch(...)
    {
        return 0;
    }
#endif
    return 1;
}
#endif
/*----------------------------------------------------------------------*/
int __stdcall isRDTSC()
{
    if(!isMMX()) 
        return 0;
    unsigned abcd[4];
    cpuid(1, abcd);
    return (abcd[3] & 0x10) != 0;
}
/*----------------------------------------------------------------------*/
int __stdcall getProcessorInfo(unsigned* ptr)
{
    if(ptr == 0 || isNotPentium()) 
        return 0;
    unsigned abcd[4];
    cpuid(0, abcd);
    ptr[0] = abcd[1]; ptr[1] = abcd[2]; ptr[2] = abcd[3];
    cpuid(1, abcd);
    ptr[3] = abcd[0]; ptr[4] = abcd[3];
    return 1;
}
/*######################################################################*/
