/*######################################################################*/
//  Copyright(C) 2003-2004 ADCLab.      www.adclab.ru
//  Written by Andry Zharov.            adc@ru.ru, adc@adclab.ru
//  08.03.2004
/*######################################################################*/
#include    <MWC.h>
/*######################################################################*/
#ifdef STRICT 
#define MPROC   WNDPROC
#else 
#define MPROC   FARPROC
#endif 
/*######################################################################*/
HINSTANCE           hModuleInstance = 0;        // if == 0 use GetModuleHandle(0);
NewObjectMSG        pNewObjectMSG   = 0;        // Default New for control window
/*######################################################################*/
LRESULT CALLBACK    WindowProc(HWND hWnd, UINT iMessage,
                               WPARAM wParam, LPARAM lParam)
{
    MWindow* pw;
    switch(iMessage)
    {
    case WM_NCCREATE:
        pw = (MWindow*)((CREATESTRUCT*)lParam)->lpCreateParams;
        if(pw == 0)
        {
            if(pNewObjectMSG != 0)
            {
                TCHAR tName[256];
                if(GetClassName(hWnd, tName, DIM(tName)) == 0)
                    break;
                pw = pNewObjectMSG(tName);
            }
        }
        SetWindowLong(hWnd, 0, LONG(pw)); 
        if(pw)
            pw->hWnd = hWnd;
        break;
    case WM_DESTROY:
        pw = (MWindow*)GetWindowLong(hWnd, 0); 
        if(pw)
        {
            RECT rt; GetWindowRect(hWnd, &rt); 
            pw->SetPos(rt);
        }
        break;
    case WM_NCDESTROY:
        pw = (MWindow*)GetWindowLong(hWnd, 0); 
        SetWindowLong(hWnd, 0, 0); 
        if(pw) 
            pw->OnDestroy();
        return DefWindowProc(hWnd, iMessage, wParam, lParam);

    case WM_PAINT:
    {
        pw = (MWindow*)GetWindowLong(hWnd, 0); 
        if(!pw) 
            break;
        RECT rc; GetClientRect(hWnd, &rc);
        PAINTSTRUCT ps; BeginPaint(hWnd, &ps);
        pw->OnPaint(ps.hdc, rc); 
        EndPaint(hWnd, &ps);
        return 0;
    }
    default:
        pw = (MWindow*)GetWindowLong(hWnd, 0);
        break;
    }
    if(pw)
    {
        int ret = pw->WndProc(iMessage, wParam, lParam);
        if(ret != -1) 
            return ret;
    }    
    return DefWindowProc(hWnd, iMessage, wParam, lParam);
}
/*######################################################################*/
LRESULT CALLBACK    MainDlgProc(HWND hWnd, UINT iMessage, 
                                WPARAM wParam, LPARAM lParam)
{
    MDialog* pw = (MDialog*)GetWindowLong(hWnd, DWL_USER);
    if(pw)
    {
        switch(iMessage)
        {
        case WM_DESTROY:
            if(pw)
            {
                RECT rt; GetWindowRect(hWnd, &rt); 
                pw->SetPos(rt);
            }
            break;
        case WM_NCDESTROY:
            SetWindowLong(hWnd, DWL_USER, 0); 
            if(pw->OldWndProc) 
            {
                CallWindowProc(MPROC(pw->OldWndProc), hWnd, iMessage, wParam, lParam);
                SetWindowLong(hWnd, GWL_WNDPROC, long(pw->OldWndProc));    
                pw->OldWndProc = 0;
            }
            pw->OnDestroy();
            return 0;
        
        case WM_QUERYDRAGICON:
            return LONG(pw->hIcon);
        case WM_GETICON:
            return LONG(pw->hIcon);

        case WM_PAINT:
            if(pw->hIcon && IsIconic(hWnd))
            {
                PAINTSTRUCT ps; BeginPaint(hWnd, &ps);
                DefWindowProc(hWnd, WM_ICONERASEBKGND, WPARAM(ps.hdc), 0);
                DrawIcon(ps.hdc, 0, 0, pw->hIcon); 
                EndPaint(hWnd, &ps); 
                return 0;
            }
            else
            {
                LRESULT ret = DefDlgProc(hWnd, iMessage, wParam, lParam);
                RECT rc; GetClientRect(hWnd, &rc);
                HDC dc = GetDC(hWnd);
                pw->OnPaint(dc, rc); 
                ReleaseDC(hWnd, dc);
                return ret;
            }
        
        case WM_ERASEBKGND:
            if(IsIconic(hWnd)) 
                return 1;
        
        case WM_NCPAINT:
        case WM_NCHITTEST:
        case WM_NCMOUSEMOVE:

        case WM_NCLBUTTONDBLCLK: 
        case WM_NCLBUTTONDOWN: 
        case WM_NCLBUTTONUP: 
        case WM_NCMBUTTONDBLCLK: 
        case WM_NCMBUTTONDOWN: 
        case WM_NCMBUTTONUP: 
        case WM_NCRBUTTONDBLCLK: 
        case WM_NCRBUTTONDOWN: 
        case WM_NCRBUTTONUP:

        case WM_MOUSEMOVE:
        case WM_SETCURSOR:

        case WM_CTLCOLORBTN:
        case WM_CTLCOLOREDIT:
        case WM_CTLCOLORDLG:
        case WM_CTLCOLORLISTBOX:
        case WM_CTLCOLORMSGBOX:
        case WM_CTLCOLORSCROLLBAR:
        case WM_CTLCOLORSTATIC:

        case WM_ACTIVATE: 
        case WM_CHAR: 
        case WM_DEADCHAR: 
        case WM_GETHOTKEY: 
        case WM_HOTKEY: 
        case WM_KEYDOWN: 
        case WM_KEYUP: 
        case WM_KILLFOCUS: 
        case WM_SETFOCUS: 
        case WM_SETHOTKEY: 
        case WM_SYSCHAR: 
        case WM_SYSDEADCHAR: 
        case WM_SYSKEYDOWN: 
        case WM_SYSKEYUP:
            {
                int ret = pw->WndProc(iMessage, wParam, lParam);
                if(ret != -1) 
                    return ret;
            }
            break;
        }
        if(pw->OldWndProc) 
            return CallWindowProc(MPROC(pw->OldWndProc), hWnd, iMessage, wParam, lParam);
    }
    return 0;
}
/*======================================================================*/
int     MDialog::MeasureItemWidth  = -1;
int     MDialog::MeasureItemHeight = -1;
/*======================================================================*/
BOOL CALLBACK   DialogProc(HWND hWnd, UINT iMessage, 
                           WPARAM wParam, LPARAM lParam)
{
    MDialog* pw;
    switch(iMessage)
    {
    case WM_INITDIALOG:
        pw = (MDialog*)lParam;
        SetWindowLong(hWnd, DWL_USER, lParam);
        if(pw) 
            pw->hWnd = hWnd;
        break;
    case WM_MEASUREITEM:
        if(lParam)
        {
            if(MDialog::MeasureItemWidth != -1)
                ((LPMEASUREITEMSTRUCT)lParam)->itemWidth  = MDialog::MeasureItemWidth;
            if(MDialog::MeasureItemHeight != -1)
                ((LPMEASUREITEMSTRUCT)lParam)->itemHeight = MDialog::MeasureItemHeight;
        }
        return FALSE;
    
    case WM_PAINT:
    case WM_CTLCOLORBTN:
    case WM_CTLCOLOREDIT:
    case WM_CTLCOLORDLG:
    case WM_CTLCOLORLISTBOX:
    case WM_CTLCOLORMSGBOX:
    case WM_CTLCOLORSCROLLBAR:
    case WM_CTLCOLORSTATIC:

    case WM_MOUSEMOVE:
    case WM_SETCURSOR:
        return FALSE;

    default:
        pw = (MDialog*)GetWindowLong(hWnd, DWL_USER);
        break;
    }
    if(pw)
    {
        int ret = pw->WndProc(iMessage, wParam, lParam);
        if(ret != -1) 
            return ret ? TRUE : FALSE;
    }    
    return FALSE;
}
/*######################################################################*/
