#ifndef __CBLIST_H__
#define __CBLIST_H__
/*######################################################################*/
struct  CBList
{
    int             m_nID;
    int             m_nPos;
    double          m_dMin, m_dMax;
    bool            m_bMax;
    double          m_dEMin;
    char*           m_szFmt;
    double*         m_dData;
    int             m_nData;

    CBList(int n=32)        
    { 
        m_nID = m_nPos = 0; 
        m_dMin = m_dMax = m_dEMin = 0.0; 
        m_bMax = false; 
        m_szFmt = "%g";
        m_nData = CutV(n, 1, 256);
        m_dData = new double[m_nData];
    }
    ~CBList()
    {
        delete m_dData;
    }

    void            Init(int id, int pos=0);
    void            SetMinMax(double mi, double ma, double emi=0.0) 
    { 
        m_dMin  = mi; 
        m_dMax  = ma; 
        m_bMax  = m_dMax > m_dMin;
        m_dEMin = emi;
    }
    void            SetFormat(char* str) { m_szFmt = (str && *str) ? str : "%g"; }
    int             GetI() { return m_nPos; }
    void            SetI(int pos=0) { m_nPos = CutV(pos, 0, m_nData-1); }
    void            Set(double d) { m_dData[m_nPos] = d; }
    double          Get();
    void            GetEdit(HWND hWnd);
    int             Proc(HWND hWnd, WPARAM, LPARAM);
    void            Fill(HWND hWnd);
};
/*######################################################################*/
#endif
