#ifndef __CHUNK_H__
#define __CHUNK_H__
/*######################################################################*/
template < class ITEM, const int CHUNKSIZE > class CHUNK;
/*----------------------------------------------------------------------*/
template < class ITEM, const int CHUNKSIZE > class CHUNK_HEAP
{
private:
    CHUNK< ITEM, CHUNKSIZE >*   m_pChunkList;
    CHUNK< ITEM, CHUNKSIZE >*   m_pCurChunk;
    ITEM*                       m_pItemLast;
    ITEM*                       m_pItemLastFree;

public:
    CHUNK_HEAP()
    {
        m_pChunkList = new CHUNK< ITEM, CHUNKSIZE >;
        m_pChunkList->m_pNext = 0;
        m_pCurChunk = m_pChunkList;
        m_pItemLast = m_pCurChunk->m_pItems - 1;
        m_pItemLastFree = m_pItemLast + CHUNKSIZE;
    }

    ~CHUNK_HEAP()
    {
        while(m_pChunkList)
        {
            CHUNK< ITEM, CHUNKSIZE >* c = m_pChunkList;
            m_pChunkList = c->m_pNext;
            delete c;
        }
    }

    ITEM* Get()
    {
        if(m_pItemLast == m_pItemLastFree)
        {
            if(!m_pCurChunk->m_pNext)
            {
                m_pCurChunk->m_pNext = new CHUNK< ITEM, CHUNKSIZE >;
                m_pCurChunk = m_pCurChunk->m_pNext;
                m_pCurChunk->m_pNext = 0;
            }
            else
                m_pCurChunk = m_pCurChunk->m_pNext;

            m_pItemLastFree = m_pCurChunk->m_pItems + (CHUNKSIZE - 1);
            m_pItemLast = m_pCurChunk->m_pItems;
        }
        else
            m_pItemLast++;

        return m_pItemLast;
    }

    void Erase()
    {
        m_pCurChunk = m_pChunkList;
        m_pItemLast = m_pCurChunk->m_pItems - 1;
        m_pItemLastFree = m_pItemLast + CHUNKSIZE;
    }
};
/*----------------------------------------------------------------------*/
template < class ITEM, const int CHUNKSIZE > class CHUNK
{
    CHUNK< ITEM, CHUNKSIZE >*   m_pNext;
    ITEM                        m_pItems[CHUNKSIZE];
    friend class CHUNK_HEAP< ITEM, CHUNKSIZE >;
    CHUNK() 
    { 
        ZeroMemory(m_pItems, sizeof(m_pItems));
    }
};
/*######################################################################*/
#endif
