#ifndef __CONFIG_FILE_H__
#define __CONFIG_FILE_H__
/*######################################################################*/
class   ConfigFile
{
private:
    unsigned char*  m_str;
    int             m_nSize;
    int             m_nPos;

    int         GetKeyStr(char* key, int& nMax, int& nPos);
    int         TestNumber(int max, int& n);
    int         GetNumber(int max, int& n, int* ival, double* dval, float* fval);

public:
    ConfigFile(char const* path, char* buff = 0, int size = 0);
    ~ConfigFile();

    bool        OK()       { return m_str != 0; }
    void        ResetPos() { m_nPos = 0;        }

    int         GetKey(int index, char* key, int size);
    int         TestKey(char* key);
    int         TestKeyValue(char* key);
    int         GetKeyValue( char* key, char*   val, int size, char*  defval=0);
    int         GetKeyValue( char* key, short&  val,           short  defval=0);
    int         GetKeyValue( char* key, int&    val,           int    defval=0);
    int         GetKeyValue( char* key, double& val,           double defval=0.0);
    int         GetKeyValue( char* key, float&  val,           float  defval=0.0f);
    int         GetKeyValueN(char* key, int*    pval, int size);
    int         GetKeyValueN(char* key, double* pval, int size);
    int         GetKeyValueN(char* key, float*  pval, int size);

    int         GetKeyValue( char* key, unsigned short& val, unsigned short defval=0)
    {
        return GetKeyValue(key, (short&)val, short(defval));
    }
    int         GetKeyValue( char* key, unsigned int&   val, unsigned int   defval=0)
    {
        return GetKeyValue(key, (int&)val, int(defval));
    }
};
/*######################################################################*/
#endif
