#ifndef __MBRUSH_H__
#define __MBRUSH_H__
/*######################################################################*/
class MBrush
{ 
private:
    HBITMAP     m_hBitmap;
    POINT       m_ptOffset;
    int         m_cx, m_cy;

public:
    MBrush()
    {
        m_hBitmap = 0;
        m_ptOffset.x = m_ptOffset.y = 0;
        m_cx = m_cy = 0;
    }

    MBrush(HINSTANCE hI, const TCHAR* name)
    {
        m_hBitmap = 0;
        SetImage(hI, name);
    }

    MBrush(const TCHAR* name_file)
    {
        m_hBitmap = 0;
        SetImage(name_file);
    }

    ~MBrush() 
    { 
        Free(); 
    }

    void    Free()
    {
        if(m_hBitmap) 
            DeleteObject(m_hBitmap);
        m_hBitmap = 0;
        m_cx = m_cy = 0;
    }

    void    SetImage(HINSTANCE, const TCHAR*);
    void    SetImage(const TCHAR*);
    void    FillRect(HDC, RECT*, HRGN hrgn0 = 0);
    int     GetWidth()  { return m_cx; }
    int     GetHeight() { return m_cy; }

    void    SetOffset(POINT pt) 
    { 
        m_ptOffset = pt; 
    }

    void    SetOffsetByParent(HWND hWnd)
    {
        RECT rc;
        GetWindowRect(hWnd, &rc);
        hWnd = GetParent(hWnd);
        if(hWnd == 0) 
            return;
        POINT pt;
        pt.x = rc.left;
        pt.y = rc.top;
        ScreenToClient(hWnd, &pt);
        SetOffset(pt);
    }

    int     OK() 
    { 
        return m_hBitmap != 0; 
    }
};
/*######################################################################*/
#endif
