#ifndef __M_LOGGER__
#define __M_LOGGER__

#include    <stdarg.h>
#include    <stdio.h>
#include    <float.h>
/*######################################################################*/
#ifndef     SZLOGFILENAME
#define     SZLOGFILENAME   "LOGFILE.TXT"
#endif
/*######################################################################*/
static
double  GetTimeMS()
{
    LARGE_INTEGER f;
    double ptime;
    if(QueryPerformanceFrequency(&f))
    {
        LARGE_INTEGER c;
        QueryPerformanceCounter(&c);
        ptime = c.QuadPart * 1e3 / f.QuadPart;
    }
    else
        ptime = GetTickCount();
    ptime = (_finite(ptime) && ptime > 0.0) ? ptime : 0.0;
    return ptime;
}
/*----------------------------------------------------------------------*/
static 
double  dTime0 = GetTimeMS() * 0.001;
/*======================================================================*/
void DELLOG()
{
    DeleteFile(SZLOGFILENAME);
}
/*----------------------------------------------------------------------*/
void WRFILE(char* str)
{
    HANDLE hf = CreateFile(SZLOGFILENAME, GENERIC_WRITE, 0,0, OPEN_ALWAYS,
                           FILE_ATTRIBUTE_NORMAL, 0);
    if(hf != INVALID_HANDLE_VALUE)
    {
        SetFilePointer(hf, 0, 0, FILE_END);
        DWORD nb;
        WriteFile(hf, str, strlen(str), &nb, 0);
        FlushFileBuffers(hf);
        CloseHandle(hf);
    }
}
/*----------------------------------------------------------------------*/
void __cdecl   WRLOG(char* frm, ...)
{
    va_list marker;
    va_start(marker, frm);
    char buff[256];
    vsprintf(buff, frm, marker);
    va_end(marker);
    WRFILE(buff);
}
/*----------------------------------------------------------------------*/
void __cdecl   WLOG(char* frm, ...)
{
    double ptime = GetTimeMS() * 0.001;
    va_list marker;
    va_start(marker, frm);
    char buff[256];
    vsprintf(buff, frm, marker);
    va_end(marker);
    strcat(buff, " [%14.6fs]\r\n");

    WRLOG(buff, ptime - dTime0);
}
/*======================================================================*/
#define     _DL()   DELLOG()
#define     _LOG    WLOG
#define     _WL     WRLOG

#ifdef  MLDEBUG
#define     DL()    DELLOG()
#define     LOG     WLOG
#define     WL      WRLOG
#else
#define     DL()
#define     LOG
#define     WL
#endif
/*######################################################################*/
#endif
