#ifndef     __MTOOLTIP_H__
#define     __MTOOLTIP_H__
/*######################################################################*/
struct  HelpWindow
{
    virtual void     __stdcall  Close() = 0;
    virtual void     __stdcall  Display(HWND hp, const TCHAR* str, int x, int y, int tout = 4000) = 0;

    static  HelpWindow* __stdcall New(int idr = 0, int* pPolygonRegion = 0, int PolygonSize = 0, RECT* pRectInPolygon = 0);
};
/*======================================================================*/
struct  ToolTipItem
{
    int     m_id;
    char*   m_str;
};
/*######################################################################*/
typedef void (__stdcall* MylpfnTimer)(HWND, UINT, UINT, DWORD);
/*----------------------------------------------------------------------*/
class   MToolTip
{
private:
    HelpWindow*     m_pHelp;
    ToolTipItem*    m_pt;
    UINT            m_nTimerID;
    MylpfnTimer     m_TimerFunc;
    int             m_nBitmapID;
    int             m_nHelp;
    int             m_nCnt;
    int             m_nHelpPreDelay;
    int             m_nHelpPostDelay;

private:
    bool    FindHelp(HWND hWnd)
    {
        POINT p; GetCursorPos(&p);
        for(int i=0; m_pt[i].m_str; ++i)
        {
            HWND h = hWnd;
            if(m_pt[i].m_id != 0)
            {
                h = GetDlgItem(hWnd, m_pt[i].m_id);
                if(h == 0) 
                    continue;
            }
            RECT rc; GetWindowRect(h, &rc);
            if(PtInRect(&rc, p))
            {
                HWND hf = GetFocus();
                if(m_nHelp != m_pt[i].m_id)
                {
                    if(m_pHelp) 
                        m_pHelp->Close(); 
                    m_pHelp = 0;
                    m_nCnt  = 0;
                    m_nHelp = m_pt[i].m_id;
                }
                else
                {
                    bool bFlag = false;
                    char str[100];
                    if(GetClassName(h, str, DIM(str)))
                    {
                        if(stricmp(str, "COMBOBOX") == 0)
                            bFlag = SendMessage(h, CB_GETDROPPEDSTATE, 0, 0) == TRUE ? true : false;
                    }
                    if(m_nCnt == 10 && bFlag == false) 
                    {
                        m_pHelp = HelpWindow::New(m_nBitmapID);
                        m_pHelp->Display(hWnd, m_pt[i].m_str, p.x, p.y, m_nHelpPostDelay);
                    }
                    if(++m_nCnt >= 11)
                        m_nCnt = 11;
                }
                if(hf)
                    SetFocus(hf);
                return true;
            }
        }
        return false;
    }

public:      
    MToolTip()
    {
        m_pHelp    = 0;
        m_pt       = 0;
        m_nHelp    = 0;
        m_nCnt     = 0;
        m_nTimerID = 0;
        m_TimerFunc = 0;
        m_nBitmapID = 0;
    }
    ~MToolTip()
    {
        Close();
        if(m_nTimerID)
            KillTimer(0, m_nTimerID);
    }

    void    Init(HWND hWnd, int nHelpPreDelay, int nHelpPostDelay, 
                 ToolTipItem* pt, MylpfnTimer func, int bmpID)
    {
        Close();
        m_nBitmapID      = bmpID;
        m_pt             = pt;
        m_nHelpPreDelay  = nHelpPreDelay;
        m_nHelpPostDelay = nHelpPostDelay;
        m_TimerFunc      = func;
        int tout = m_nHelpPreDelay / 10;
        if(tout < 10)
            tout = 10;
        if(m_nHelpPreDelay > 0 && m_pt != 0 && m_TimerFunc != 0) 
            m_nTimerID = SetTimer(hWnd, 0, tout, m_TimerFunc);
    }

    void    Close()
    {
        if(m_pHelp) 
            m_pHelp->Close(); 
        m_pHelp = 0;
    }

    void    ToolTips(HWND hWnd)
    {
        POINT p; GetCursorPos(&p);
        for(HWND h = WindowFromPoint(p); h && h != hWnd; h = GetParent(h));
        if(h == hWnd)
            if(FindHelp(hWnd))
                return;
        m_nHelp = 0;
    }

};
/*######################################################################*/
#endif
