/*######################################################################*/
//  Copyright(C) 2003-2004 ADCLab.      www.adclab.ru
//  Written by Andry Zharov.            adc@ru.ru, adc@adclab.ru
//  08.03.2004
/*######################################################################*/
#ifndef __MTYPES_H__
#define __MTYPES_H__
/*######################################################################*/
#if !defined(S8)
    typedef signed char     S8, *PS8;
#endif

#if !defined(U8)
    typedef unsigned char   U8, *PU8;
#endif

#if !defined(S16)
    typedef signed short    S16, *PS16;
#endif

#if !defined(U16)
    typedef unsigned short  U16, *PU16;
#endif

#if !defined(S32)
    typedef signed long     S32, *PS32;
#endif

#if !defined(U32)
    typedef unsigned long   U32, *PU32;
#endif

#ifdef  WIN32
#if !defined(S64)
    typedef union
    {
        struct
        {
            U32             LowPart;
            S32             HighPart;
        } u;
        signed __int64      QuadPart;
    } S64;
#endif

#if !defined(U64)
    typedef union
    {
        struct
        {
            U32             LowPart;
            U32             HighPart;
        } u;
        unsigned __int64    QuadPart;
    } U64;
#endif
#endif

#ifndef DIM
#define DIM(a)      (sizeof(a) / sizeof(a[0]))
#endif
/*######################################################################*/
#ifdef  __cplusplus
/*======================================================================*/
template <class T> inline T    CutV(T v, T mi, T ma)
{
    if(v < mi) v = mi; else if(v > ma) v = ma; return v;
}
/*......................................................................*/
template <class T> inline void Cut(T& v, T mi, T ma)
{
    if(v < mi) v = mi; else if(v > ma) v = ma;
}
/*----------------------------------------------------------------------*/
template <class T> inline void MiMa(T v, T& mi, T& ma)
{
    if(v < mi) mi = v; else if(v > ma) ma = v;
}
/*----------------------------------------------------------------------*/
template <class T> inline void Swap(T& v1, T& v2)
{
    T t = v1; v1 = v2; v2 = t;
}
/*======================================================================*/
#endif
/*######################################################################*/
#endif
