/*######################################################################*/
//  Copyright(C) 2003-2004 ADCLab.      www.adclab.ru
//  Written by Andry Zharov.            adc@ru.ru, adc@adclab.ru
//  08.03.2004
/*######################################################################*/
#ifndef __MWC_H__
#define __MWC_H__

#include    <Windows.h>
#include    <CommCtrl.h> 
#include    <Tchar.h>

#include    "MTypes.h"
/*######################################################################*/
LRESULT CALLBACK    WindowProc( HWND, UINT, WPARAM, LPARAM);
BOOL    CALLBACK    DialogProc( HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK    MainDlgProc(HWND, UINT, WPARAM, LPARAM);
/*######################################################################*/
class   MsgWnd;
class   MClass;
class   MApp;
class   MWindowBase;
class   MWindow;
class   MDialog;
class   MMemDCWindow;
class   MIconTaskBar;

typedef MWindow*    (* NewObjectMSG)(LPTSTR);   // pass WindowClass name
/*======================================================================*/
extern
NewObjectMSG        pNewObjectMSG;              // Default New for control window
extern
HINSTANCE           hModuleInstance;            // if == 0 use GetModuleHandle(0);
/*######################################################################*/
class   MsgWnd;

typedef int (MsgWnd::* MSGF)    ();
typedef int (MsgWnd::* MSGF_W)  (WPARAM);
typedef int (MsgWnd::* MSGF_L)  (LPARAM);
typedef int (MsgWnd::* MSGF_WL) (WPARAM, LPARAM);

struct  MItem
{
    UINT        iMessage;
    WPARAM      wParamLo;
    WPARAM      wParamHi;
    int         funArgs;
    union
    {
    MSGF        fun;
    MSGF_W      funW;
    MSGF_L      funL;
    MSGF_WL     funWL;
    };
};
/*======================================================================*/
class   MsgWnd
{
private:
    UINT        m_uMsg;

public:
    UINT        GetCurrentMessage() { return m_uMsg; }
/*----------------------------------------------------------------------*/
    virtual MItem const* GetMessageMap() const { return 0; }
/*======================================================================*/
int     DispatchMsg(UINT iMsg, WPARAM wParam, LPARAM lParam)
{
    m_uMsg = 0;
    MItem const* p = GetMessageMap();
    if(p) 
        for(; p->fun; ++p) 
        if((iMsg == p->iMessage) && 
           ((p->wParamLo == 0) || (p->wParamLo == LOWORD(wParam)) ||
            (p->wParamHi && (p->wParamLo <= LOWORD(wParam)) && (p->wParamHi >= LOWORD(wParam)))))
        {
            m_uMsg = iMsg;
            switch(p->funArgs)
            {
            case 0:
                return (this->*p->fun)();
            case 1:
                return (this->*p->funW)(wParam);
            case 2:
                return (this->*p->funL)(lParam);
            case 3:
                return (this->*p->funWL)(wParam, lParam);
            default:
                break;
            }
        }
    return -1;
}
};
/*######################################################################*/
#define D_MESSAGE_MAP()                                             \
private:                                                            \
    static MItem const messageMap[];                                \
public:                                                             \
    virtual MItem const* GetMessageMap() const { return messageMap; }

#define B_MESSAGE_MAP(theClass)                                     \
    MItem const theClass::messageMap[] = {

#define MSG_ENTRY(theClass, msg, proc)                              \
    { msg, 0,0, 0, (MSGF)(&theClass::proc) },
#define MSG_ENTRY_W(theClass, msg, proc)                            \
    { msg, 0,0, 1, (MSGF)(MSGF_W)(&theClass::proc) },
#define MSG_ENTRY_L(theClass, msg, proc)                            \
    { msg, 0,0, 2, (MSGF)(MSGF_L)(&theClass::proc) },
#define MSG_ENTRY_WL(theClass, msg, proc)                           \
    { msg, 0,0, 3, (MSGF)(MSGF_WL)(&theClass::proc) },

#define MSG_ENTRYW(theClass, msg, wParam, proc)                     \
    { msg, wParam,0, 0, (MSGF)(MSGF)(&theClass::proc) },
#define MSG_ENTRYW_W(theClass, msg, wParam, proc)                   \
    { msg, wParam,0, 1, (MSGF)(MSGF_W)(&theClass::proc) },
#define MSG_ENTRYW_L(theClass, msg, wParam, proc)                   \
    { msg, wParam,0, 2, (MSGF)(MSGF_L)(&theClass::proc) },
#define MSG_ENTRYW_WL(theClass, msg, wParam, proc)                  \
    { msg, wParam,0, 3, (MSGF)(MSGF_WL)(&theClass::proc) },

#define MSG_ENTRYM(theClass, msg, wParamLo, wParamHi, proc)         \
    { msg, wParamLo,wParamHi, 0, (MSGF)(MSGF)(&theClass::proc) },
#define MSG_ENTRYM_W(theClass, msg, wParamLo, wParamHi, proc)       \
    { msg, wParamLo,wParamHi, 1, (MSGF)(MSGF_W)(&theClass::proc) },
#define MSG_ENTRYM_L(theClass, msg, wParamLo, wParamHi, proc)       \
    { msg, wParamLo,wParamHi, 2, (MSGF)(MSGF_L)(&theClass::proc) },
#define MSG_ENTRYM_WL(theClass, msg, wParamLo, wParamHi, proc)      \
    { msg, wParamLo,wParamHi, 3, (MSGF)(MSGF_WL)(&theClass::proc) },

#define MSG_ENTRY_COMMAND(theClass, wParam, proc)                   \
    MSG_ENTRYW(theClass, WM_COMMAND, wParam, proc)
#define MSG_ENTRY_COMMANDM(theClass, wParamLo, wParamHi, proc)      \
    MSG_ENTRYM(theClass, WM_COMMAND, wParamLo, wParamHi, proc)
#define MSG_ENTRY_COMMAND_W(theClass, wParam, proc)                 \
    MSG_ENTRYW_W(theClass, WM_COMMAND, wParam, proc)
#define MSG_ENTRY_COMMANDM_W(theClass, wParamLo, wParamHi, proc)    \
    MSG_ENTRYM_W(theClass, WM_COMMAND, wParamLo, wParamHi, proc)
#define MSG_ENTRY_COMMAND_L(theClass, wParam, proc)                 \
    MSG_ENTRYW_L(theClass, WM_COMMAND, wParam, proc)
#define MSG_ENTRY_COMMANDM_L(theClass, wParamLo, wParamHi, proc)    \
    MSG_ENTRYM_L(theClass, WM_COMMAND, wParamLo, wParamHi, proc)
#define MSG_ENTRY_COMMAND_WL(theClass, wParam, proc)                \
    MSG_ENTRYW_WL(theClass, WM_COMMAND, wParam, proc)
#define MSG_ENTRY_COMMANDM_WL(theClass, wParamLo, wParamHi, proc)   \
    MSG_ENTRYM_WL(theClass, WM_COMMAND, wParamLo, wParamHi, proc)

#define MSG_ENTRY_SYSCOMMAND(theClass, wParam, proc)                \
    MSG_ENTRYW_L(theClass, WM_SYSCOMMAND, wParam, proc)
#define MSG_ENTRY_SYSCOMMANDM(theClass, wParamLo, wParamHi, proc)   \
    MSG_ENTRYM_L(theClass, WM_SYSCOMMAND, wParamLo, wParamHi, proc)

#define E_MESSAGE_MAP() { 0, 0,0, 0, 0 } };
/*######################################################################*/
class   MClass
{
private:
    TCHAR       szClassName[50];

public:
    MClass()                  { szClassName[0] = 0; }
    MClass(const TCHAR* name) { Initialize(name);   }
    
    TCHAR const*    GetClassName() const { return szClassName; }
/*----------------------------------------------------------------------*/
    virtual void    Register(WNDCLASSEX&) = 0;
/*======================================================================*/
void    Initialize(const TCHAR* name)
{
    static TCHAR DefName[] = "MicroMFCMainClass";
    if(!name || !*name) 
        name = DefName; 
    _tcsncpy(szClassName, name, DIM(szClassName)-1);
}
/*----------------------------------------------------------------------*/
bool    RegisterClass()
{
    WNDCLASSEX wc;
    wc.cbSize        = sizeof(wc);
    wc.style         = 0;
    wc.hIcon         = 0;
    wc.hIconSm       = 0;
    wc.hCursor       = LoadCursor(0, IDC_ARROW);
    wc.hbrBackground = HBRUSH(GetStockObject(WHITE_BRUSH));
    wc.lpszMenuName  = 0;
    Register(wc);
    wc.lpszClassName = szClassName;
    wc.lpfnWndProc   = ::WindowProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = sizeof(this)+sizeof(DWORD);
    wc.hInstance     = hModuleInstance ? hModuleInstance : GetModuleHandle(0);
    return (RegisterClassEx(&wc)) ? true : false; 
}
};
/*######################################################################*/
class   MApp
{
private:
    HACCEL      hAccel;
    HWND        hWnd;
    HWND        hDlg;
    bool        bMode;

public:
    MApp(const TCHAR* accel=0)
    {
        bMode = true;
        hWnd = hDlg = 0;
        hAccel = 0;
        if(accel)
            hAccel = LoadAccelerators(hModuleInstance ? hModuleInstance : GetModuleHandle(0), accel);
    }

    HACCEL  GetAccel()         { return hAccel; }
    void    SetWnd(HWND h =0)  { hWnd  = h; }
    void    SetDlg(HWND h =0)  { hDlg  = h; }
    void    SetRunMode(bool b) { bMode = b; }
/*----------------------------------------------------------------------*/
    virtual bool    OnIdle()   { return true; }
/*======================================================================*/
int     Run()
{
    MSG msg;
    for(;;)
    {
        if(PeekMessage(&msg, 0, 0, 0, PM_REMOVE))
        {
            if(msg.message == WM_QUIT) 
                return msg.wParam;
            if(hWnd && hAccel && TranslateAccelerator(hWnd, hAccel, &msg)) 
                continue;
            if(hDlg && IsDialogMessage(hDlg, &msg)) 
                continue;
            TranslateMessage(&msg); 
            DispatchMessage(&msg);
            continue;
        }
        if(OnIdle() && bMode) 
            WaitMessage();
    }
}
};
/*######################################################################*/
class   MWindowBase : public MsgWnd
{
protected:
    HWND        hWnd;
    int         px, py;
    int         wdx, wdy;

public:
    MWindowBase() 
    { 
        hWnd = 0; 
        px = py = wdx = wdy = 0;
    }

    void            GetPos( int&  x, int&  y) const { x = px;   y = py;   }
    void            GetSize(int& dx, int& dy) const { dx = wdx; dy = wdy; }
    void            SetPos(RECT& rc) 
    { 
        px = rc.left; wdx = rc.right -px + 1;
        py = rc.top;  wdy = rc.bottom-py + 1;
    }
    HWND            GetWnd() const           { return hWnd; }
    int             OK() const               { return hWnd != 0; }
    void            Show(int nCmd) const     { if(hWnd) ShowWindow(hWnd, nCmd); }
    void            Update() const           { if(hWnd) UpdateWindow(hWnd); }
    void            IRect(BOOL ef=0) const   { if(hWnd) InvalidateRect(hWnd, 0, ef); }
    void            Activate(BOOL b=0) const { if(hWnd) SendMessage(hWnd, WM_NCACTIVATE, b, 0); }
    void            BringToTop() const       { if(hWnd) BringWindowToTop(hWnd); }
    void            Destroy() const          { if(hWnd) DestroyWindow(hWnd); }
/*----------------------------------------------------------------------*/
    virtual void    OnDestroy() { hWnd = 0; };
    virtual void    OnPaint(HDC, RECT&) {};
/*======================================================================*/
virtual
int     WndProc(UINT iMessage, WPARAM wParam, LPARAM lParam)
{
    return DispatchMsg(iMessage, wParam, lParam);
}
/*----------------------------------------------------------------------*/
virtual
int     Msg(const TCHAR* str, int style=MB_OK)
{
    TCHAR title[100]; 
    GetWindowText(hWnd, title, DIM(title)-1);
    HWND h = GetFocus();
    int ret = MessageBox(hWnd, str, title, style);
    SetFocus(h); 
    return ret;
}
/*----------------------------------------------------------------------*/
int     __cdecl MsgF(int style, char* frm, ...)
{
    TCHAR title[100]; 
    GetWindowText(hWnd, title, DIM(title)-1);
    HWND h = GetFocus();
    va_list marker;
    va_start(marker, frm);
    char buff[256]; 
    wvsprintf(buff, frm, marker);
    va_end(marker);
    int ret = MessageBox(hWnd, buff, title, style);
    SetFocus(h); 
    return ret;
}
/*----------------------------------------------------------------------*/
virtual
void    MoveWindowTo(int x, int y)
{
    RECT rt; GetWindowRect(hWnd, &rt);
    if(x < -9999 && y < -9999) 
    { 
        x = rt.left; y = rt.top; 
    }
    int mx = GetSystemMetrics(SM_CXSCREEN)-(rt.right-rt.left); 
    if(x < -999) 
        x = mx >> 1;
    Cut(x, 0, mx); 
    int my = GetSystemMetrics(SM_CYSCREEN)-(rt.bottom-rt.top); 
    if(y < -999) 
        y = my >> 1;
    Cut(y, 0, my);
    SetWindowPos(hWnd, NULL, x, y, rt.right-rt.left, rt.bottom-rt.top, 
                 IsWindowVisible(hWnd) ? (SWP_NOZORDER|SWP_DRAWFRAME|SWP_SHOWWINDOW) : 
                                          SWP_HIDEWINDOW);
}
};
/*######################################################################*/
class   MWindow : public MWindowBase
{
private:
    friend LRESULT CALLBACK ::WindowProc( HWND, UINT, WPARAM, LPARAM);

public:
/*----------------------------------------------------------------------*/
HWND    Create(const MClass& wc, const TCHAR* title, DWORD style, DWORD estyle,
               int x, int y, int wid, int hei, HWND hParent, HMENU hm)
{
    hWnd = CreateWindowEx(estyle, wc.GetClassName(), title, style,
                          x, y, wid, hei, hParent, hm, 
                          hModuleInstance ? hModuleInstance : GetModuleHandle(0), this);
    if(hWnd) 
        MoveWindowTo(px = x, py = y); 
    return hWnd;
}
};
/*######################################################################*/
class   MMemDCWindow : public MWindow
{
private:

virtual void    OnPaint(HDC hDC, RECT& rc)
{
    int wid = rc.right - rc.left + 1;
    int hei = rc.bottom - rc.top + 1;
    HDC hMemDC = CreateCompatibleDC(hDC); 
    if(hMemDC == 0) 
        return;
    HBITMAP hBmp = CreateCompatibleBitmap(hDC, wid, hei);
    HBITMAP hOb = HBITMAP(SelectObject(hMemDC, hBmp));

    RECT rc1 = rc;
    OnDraw(hMemDC, rc1);

    BitBlt(hDC, rc.left, rc.top, wid, hei, hMemDC, rc.left, rc.top, SRCCOPY);
    SelectObject(hMemDC, hOb); 
    DeleteObject(hBmp); 
    DeleteDC(hMemDC);
}
/*----------------------------------------------------------------------*/
public:

    virtual void    OnDraw(HDC, RECT&) {};
};
/*######################################################################*/
class   MDialog : public MWindowBase
{
private:
    static int  MeasureItemWidth;
    static int  MeasureItemHeight;
    HICON       hIcon;
    WNDPROC     OldWndProc;

    friend BOOL    CALLBACK ::DialogProc( HWND, UINT, WPARAM, LPARAM);
    friend LRESULT CALLBACK ::MainDlgProc(HWND, UINT, WPARAM, LPARAM);

public:
    MDialog() 
    { 
        hIcon = 0;
        OldWndProc = 0;
    }
    
    void    SetIcon(HICON _hIcon) { hIcon = _hIcon; }
    HICON   GetIcon()             { return hIcon;   }
/*----------------------------------------------------------------------*/
    static void     SetMeasureItemSize(int wid=-1, int hei=-1)
    {
        MeasureItemWidth  = wid;
        MeasureItemHeight = hei;
    }
/*----------------------------------------------------------------------*/
HWND    Create(const TCHAR* dlg, int x, int y, HWND hParent)
{
    hWnd = CreateDialogParam(hModuleInstance ? hModuleInstance : GetModuleHandle(0), 
                             dlg, hParent, DLGPROC(DialogProc), long(this));
    if(hWnd) 
    {
        OldWndProc = WNDPROC(GetWindowLong(hWnd, GWL_WNDPROC));
        SetWindowLong(hWnd, GWL_WNDPROC, long(MainDlgProc));    
        if(hIcon) 
            SendMessage(hWnd, WM_SETICON, ICON_BIG, DWORD(hIcon));
        MoveWindowTo(px = x, py = y); 
    }
    return hWnd;
}
};
/*######################################################################*/
class   MIconTaskBar
{
private:
    HWND        hWnd;
    unsigned    uD;
    unsigned    uMsg;
    bool        isValid;

public:
    MIconTaskBar()
    {
        isValid = false; 
        hWnd = 0; uD = 0; uMsg = 0;
    }

    ~MIconTaskBar()
    {
        if(IsWindow(hWnd)) 
            Destroy();
    }
/*======================================================================*/
bool    Initialize(HWND _hWnd, HICON hi, unsigned id, unsigned msg, const TCHAR* tips)
{ 
    if(isValid) 
        Destroy();
    if(!_hWnd) 
        return false;
    
    NOTIFYICONDATA nim;
    nim.cbSize = sizeof(NOTIFYICONDATA);
    nim.hWnd   = hWnd = _hWnd;
    nim.uID    = uD = id;
    nim.hIcon  = hi;
    nim.uCallbackMessage = uMsg = msg;
    unsigned flag = (msg) ? NIF_MESSAGE : 0;
    if(hi)   
        flag |= NIF_ICON;
    if(tips && *tips) 
        _tcscpy(nim.szTip, tips), flag |= NIF_TIP;
    else              
        nim.szTip[0] = 0;
    nim.uFlags = flag;
    if(Shell_NotifyIcon(NIM_ADD, &nim)) 
        isValid = true;
    return isValid;
}
/*----------------------------------------------------------------------*/
void    MIconTaskBar::Destroy()
{ 
    if(!isValid) 
        return;

    NOTIFYICONDATA nim;
    nim.cbSize = sizeof(NOTIFYICONDATA);
    nim.hWnd   = IsWindow(hWnd) ? hWnd : 0;
    nim.uID    = uD;
    nim.hIcon  = 0;
    nim.uCallbackMessage = 0;
    nim.uFlags = NIF_ICON;
    nim.szTip[0] = 0;
    Shell_NotifyIcon(NIM_DELETE, &nim);
    isValid = 0;
}
/*----------------------------------------------------------------------*/
void    MIconTaskBar::Set(HICON hi, const TCHAR* tips)
{ 
    if(!isValid) 
        return;
    
    NOTIFYICONDATA nim;
    nim.cbSize = sizeof(NOTIFYICONDATA);
    nim.hWnd   = hWnd;
    nim.uID    = uD;
    nim.hIcon  = hi;
    nim.uCallbackMessage = uMsg;
    unsigned flag = (uMsg) ? NIF_MESSAGE : 0;
    if(hi)   
        flag |= NIF_ICON;
    if(tips && *tips) 
        _tcscpy(nim.szTip, tips), flag |= NIF_TIP;
    else              
        nim.szTip[0] = 0;
    nim.uFlags = flag;
    if(!Shell_NotifyIcon(NIM_MODIFY, &nim))
    {
        nim.uFlags |= NIF_MESSAGE;
        Shell_NotifyIcon(NIM_ADD, &nim);
    }
}
};
/*######################################################################*/
#endif
