#ifndef __MYDELAY_H__
#define __MYDELAY_H__
/*######################################################################*/
class   MyTimer
{
private:
    BOOL        m_bFlags;
    __int64     m_n64CpuClocks;

/*----------------------------------------------------------------------*/
public:
    MyTimer()
    {
        m_n64CpuClocks = 0L;
        LARGE_INTEGER t;
        m_bFlags = QueryPerformanceFrequency(&t);
        if(m_bFlags)
        {
            m_n64CpuClocks = t.QuadPart;
            if(m_n64CpuClocks == 0)
                m_bFlags = 0;
        }
        else 
        {
            m_n64CpuClocks = 0;
        }
    }

    void    Delay(unsigned __int64 ns)  // delay in NS
    {
        if(m_bFlags)
        {
            unsigned __int64 t;
            LARGE_INTEGER v;
            QueryPerformanceCounter(&v);
            t = v.QuadPart;
            ns = m_n64CpuClocks * ns / 1000000000;
            do
                QueryPerformanceCounter(&v);
            while(v.QuadPart - t < ns);
        }
        else
        {
            if(ns < 1000) 
                return;
            unsigned t = GetTickCount();
            unsigned ms = unsigned((ns + 500000) / 1000000);
            while(GetTickCount() - t < ms);
        }
    }

    double  GetCPUSpeed()       // freq in MHz
    {
        return double(m_n64CpuClocks) / 1e6;
    }

    __int64 GetCPUSpeedN()      // clock per second
    {
        return m_n64CpuClocks;
    }

    double  GetTime()           // time in NS
    {
        if(m_bFlags) 
        {
            LARGE_INTEGER v;
            QueryPerformanceCounter(&v);
            return v.QuadPart * 1e9 / m_n64CpuClocks;
        }
        return GetTickCount() * 1e6;
    }
};
/*######################################################################*/
#endif
