#ifndef __MYTIMERC_H__
#define __MYTIMERC_H__

#include    "isMMX.h"
/*######################################################################*/
class   MyTimerC
{
private:
    int         m_nFlags;
    __int64     m_n64CpuClocks;
    unsigned    m_nTimerLatentcy;

/*----------------------------------------------------------------------*/
__int64     GetCpuSpeed(int tout)
{
    __int64 StartTicks, EndTicks;
    int     timeStart, timeStop;               
 
    timeStart = GetTickCount();
    for(;;)
    {
        timeStop = GetTickCount();       
        if((timeStop-timeStart) > 1)
        {
            StartTicks = getRDTSC();      
            break;  
        }   
    }
    timeStart = timeStop;               
    for(;;)
    {
        timeStop = GetTickCount();           
        if((timeStop-timeStart) > tout)
        {
            EndTicks = getRDTSC();
            break;  
        }   
    }
    return EndTicks - StartTicks;
}
/*----------------------------------------------------------------------*/
public:
    MyTimerC(int tout = 1000)           // tout in MS
    {
        m_nFlags = isRDTSC();
        if(m_nFlags)
        {
            for(unsigned tl = 0, i = 0; i < 10; ++i)
            {
                unsigned t = unsigned(getRDTSC());
                tl += unsigned(getRDTSC()) - t;
            }
            m_nTimerLatentcy = tl / i;
            if(tout <  100) 
                tout = 100; 
            else 
            if(tout > 5000) 
                tout = 5000;
            m_n64CpuClocks = GetCpuSpeed(tout);
            m_n64CpuClocks = m_n64CpuClocks * 1000 / tout; 
            if(m_n64CpuClocks == 0)
                m_nFlags = 0;
        }
        else 
        {
            m_n64CpuClocks = 0;
            m_nTimerLatentcy = 0;
        }
    }

    void    Delay(unsigned __int64 ns)  // delay in NS
    {
        if(m_nFlags)
        {
            unsigned __int64 t = getRDTSC();
            ns = m_n64CpuClocks * ns / 1000000000;
            if(ns < m_nTimerLatentcy) 
                return;
            ns -= m_nTimerLatentcy;
            while(getRDTSC() - t < ns);
        }
        else
        {
            if(ns < 1000) 
                return;
            unsigned t = GetTickCount();
            unsigned ms = unsigned((ns + 500000) / 1000000);
            while(GetTickCount() - t < ms);
        }
    }

    double  GetCPUSpeed()               // freq in MHz
    {
        return double(m_n64CpuClocks) / 1e6;
    }

    __int64 GetCPUSpeedN()              // clock per second
    {
        return m_n64CpuClocks;
    }

    double  GetTime()                   // time in NS
    {
        if(m_nFlags) 
            return __int64(getRDTSC()) * 1e9 / m_n64CpuClocks;
        return GetTickCount() * 1e6;
    }

    int     GetFlags()
    {
        return m_nFlags;
    }
};
/*######################################################################*/
#endif
