#ifndef     __WMACROS_H__
#define     __WMACROS_H__
/*######################################################################*/
#define MBOK                        (MB_ICONASTERISK|MB_OK)
#define MBSTOP                      (MB_ICONSTOP|MB_OK)
#define MBOKCANCEL                  (MB_OKCANCEL|MB_DEFBUTTON1|MB_ICONASTERISK)
/*======================================================================*/
#define GetDI(idc)                  GetDlgItem(hWnd, idc)
#define SetCheck(idc, f)            CheckDlgButton(hWnd, idc, (f) ? BST_CHECKED : BST_UNCHECKED)
#define IsChecked(idc)              ((IsDlgButtonChecked(hWnd, idc) == BST_CHECKED) ? 1 : 0)
#define EnableItem(idc, f)          EnableWindow(GetDI(idc), f)
#define CheckMenu(hm, idc, f)       CheckMenuItem(hm, idc, (f) ? MF_CHECKED : MF_UNCHECKED)
#define EnableMenu(hm, idc, f)      EnableMenuItem(hm, idc, (f) ? MF_ENABLED : MF_GRAYED)
#define IsEnabled(idc)              IsWindowEnabled(GetDI(idc))
#define ShowItem(idc, f)            SetWindowPos(GetDI(idc), NULL,0,0,0,0, SWP_NOMOVE|SWP_NOSIZE| ((f) ? SWP_SHOWWINDOW : SWP_HIDEWINDOW))
#define IsButtonPress(idc)          (SendDlgItemMessage(hWnd, idc, BM_GETSTATE, 0, 0) & BST_PUSHED) 

#define CbAddString(idc, s)         SendDlgItemMessage(hWnd, idc, CB_ADDSTRING, 0, LONG(LPSTR(s)))
#define CbInsertString(idc, s, i)   SendDlgItemMessage(hWnd, idc, CB_INSERTSTRING, i, LONG(LPSTR(s)))
#define CbGetIndex(idc)             short(SendDlgItemMessage(hWnd, idc, CB_GETCURSEL, 0, 0))
#define CbReset(idc)                SendDlgItemMessage(hWnd, idc, CB_RESETCONTENT, 0, 0)
#define CbSet(idc, i)               SendDlgItemMessage(hWnd, idc, CB_SETCURSEL, i, 0)
#define CbGetSize(idc)              SendDlgItemMessage(hWnd, idc, CB_GETCOUNT, 0, 0) 
#define CbDelString(idc, i)         SendDlgItemMessage(hWnd, idc, CB_DELETESTRING, i, 0)

#define LbAddString(idc, s)         SendDlgItemMessage(hWnd, idc, LB_ADDSTRING, 0, LONG(LPSTR(s)))
#define LbInsertString(idc, s, i)   SendDlgItemMessage(hWnd, idc, LB_INSERTSTRING, i, LONG(LPSTR(s)))
#define LbGetIndex(idc)             short(SendDlgItemMessage(hWnd, idc, LB_GETCURSEL, 0, 0))
#define LbReset(idc)                SendDlgItemMessage(hWnd, idc, LB_RESETCONTENT, 0, 0)
#define LbSet(idc, i)               SendDlgItemMessage(hWnd, idc, LB_SETCURSEL, i, 0)
#define LbGetSize(idc)              SendDlgItemMessage(hWnd, idc, LB_GETCOUNT, 0, 0) 
#define LbDelString(idc, i)         SendDlgItemMessage(hWnd, idc, LB_DELETESTRING, i, 0)
#define LbSetTop(idc, i)            SendDlgItemMessage(hWnd, idc, LB_SETTOPINDEX, i, 0) 
#define LbGetTop(idc)               SendDlgItemMessage(hWnd, idc, LB_GETTOPINDEX, 0, 0) 
#define LbSetSel(idc, i, f)         SendDlgItemMessage(hWnd, idc, LB_SETSEL, f, i)

#define SetDIText(idc, pt)          SendDlgItemMessage(hWnd, idc, WM_SETTEXT, 0, LPARAM(pt))
#define GetDIText(idc, pt, size)    SendDlgItemMessage(hWnd, idc, WM_GETTEXT, size, LPARAM(pt))
#define SendDIMsg(idc, msg, w, l)   SendDlgItemMessage(hWnd, idc, msg, WPARAM(w), LPARAM(l))
#define PostMsg(msg, w, l)          PostMessage(hWnd, msg, WPARAM(w), LPARAM(l))
/*######################################################################*/
#endif
