#ifndef __CommLight_H__
#define __CommLight_H__
/*######################################################################*/
// Written by Andry Zharov
// 20.08.1998
/*######################################################################*/
struct  ICommLight
{
    virtual unsigned __stdcall  AddRef() = 0;
    virtual unsigned __stdcall  Release() = 0;

    virtual int      __stdcall  Open(int pNum, int baud, int bit, int stop, int parity, int flow) = 0;
    virtual void     __stdcall  Close() = 0;

    virtual int      __stdcall  Write(char* buff, int cnt, unsigned tout=10000) = 0;
    virtual int      __stdcall  Read( char* buff, int cnt, unsigned tout=10000) = 0;
    virtual unsigned __stdcall  Get() = 0;
    virtual unsigned __stdcall  Test(int i) = 0;

    virtual void     __stdcall  Clear() = 0;
    virtual void     __stdcall  EscapeFunction(unsigned fun) = 0;
    virtual unsigned __stdcall  GetModemStatus() = 0;

    virtual unsigned __stdcall  Look(int code) = 0;
};
/*----------------------------------------------------------------------*/
ICommLight*          __stdcall  ICommLightCreate();
/*----------------------------------------------------------------------*/
#define FC_DTRDSR               0x01
#define FC_RTSCTS               0x02
#define FC_XONXOFF              0x04
/*----------------------------------------------------------------------*/
#define LOOK_BAUD               1   // Baud Rate 
#define LOOK_STOP               2   // Stop Bits 
#define LOOK_PARITY             3   // Parity 
#define LOOK_FLOW               4   // Flow Control 
#define LOOK_SIZE               5   // Size 
#define LOOK_PORT               6   // Port 
#define LOOK_CONNECT            7   // Connected 
#define LOOK_LASTERROR          8   // LastError 
#define LOOK_LASTERRORSTRING    9   // LastErrorString 
/*----------------------------------------------------------------------*/
#define CL_WRITE_ERROR          1
#define CL_READ_ERROR           2
#define CL_READ_ERROR_RXPARITY  3
#define CL_READ_ERROR_FRAME     4
#define CL_READ_ERROR_OVERRUN   5
/*######################################################################*/
#endif
