/*######################################################################*/
//       EL100E, EL100SD, PL100SD, PL200SD.
//
//            
//  .   ,     
//   C++  WIN32. 
//            ,  
//    .   
//     ,     
//     . 
//
//      EL100xx, PL100xx  USB   
//    ,       
//          
//     FIFO .   FIFO 
//      64   32  . 
//    PC    32 .   
//    ,      . 
//         ,   , 
//    ,       . 
//    ,       
//   .       
//    10Hz,         
//  32 / 10 = 3.2.      
//    3.2.      
//         . 
//   ,     256 ,    
//   4    . Fos = 4**W * Fs.   
//     10,  10*256 = 2560Hz    14
//  .  , ,    256  
//  ,     .      
//     ,   
//    .     
//         
//   .      
//      .
//           16
//           
//  16  .       
//   , -      
//     .      
//    .     
//      USB ,  
//     .    
//     .     
//    ,     
//     .
//      EL100xx    
//   100KHz.       
//   60KHz.
//
//         ,    
//            .
//
//            . 
//         .
//           .
//      ,  
//    ,     . 
//   ,    .    
//      50KHz.   
//    ,    
//   60KHz.     25KHz,    
//      100KHz.
//       ,  ,     
//  Flash  .    6K .   
//       .    
//  20000 . ,      
//    ,        
//    .     
//   .
//             
//      .
//
//         ,  ,    
//   .       
//   .       
//    .      
//     .
//
//           
//    SD/MMC/MMC+ Card.    
//      SPI.    SD
//      SPI.   "Silicon Power"   
//  "AData". 
//           100KHz  
//   High Speed Card.  ,   
//    SD  MMC+.    
//  "Transcend SD 80x", "Transcend SD 150x", "Transcend MMC plus". 
//           
//   .      128Mb 
//  4Gb.      FAT16.
//          *.ALF 
//     SD .      
//     . 
//     FAT16  ,   ,
//  -     FAT   - , 
//     FAT32,  .     
//   ,       . 
//        ,   
//  .  ,    FAT16  
//       . 
//        
//     FAT32.
//      ,       
//     SD .     512.
//          
//     .     
//         .   
//       , 
//         .
//       . 
//      ,    , 
//      FAT16.    
//      .   
//           
//  .
//       *.ALF.      8
//       "%04dFileName.ALF".   
//      .     
//      *.ALF,     
//  SD .
//            
//  ,       
//  .      "Read Only" 
//  ( ). 
//     ALF        
//      S-Recorder.     
//    ,         
//  ALF ,    "Read Only".    
//     .      .
//           
//    .     
//  .  ALF     ,
//           
//   .  ,  S-Recorder, 
//  ALF ,       
//  .     . 
//    .     
//    1 .     
//  .
//        ,     .  
//      ,     . 
//          
//    FAT16  64Kb,    
//       .   , 
//      .  , 
//    ,    SD   
//   512-1024Kb,      ,
//     ,      . 
//          
//   .  ,   
//     1Gb    1KHz 
//      6 ,     
//  ,       
//  .
//
//             
//  SD   .        
//     .     
//    ,     
//  .         
//     .      
//       .    
//        Flash . 
//    ,  .   
//       .     
//    , SD ,   .
/*######################################################################*/
#define     FIRST_LOAD          //      .
#define     MULTI_GENERATOR     //     .
#define     SAVE_GENERATOR      //   
#define     CLEAR_GENERATOR     //    
#define     SAVE_STREAM         //      .
#define     SAVE_FILE           //     SD.
#define     STOP_GENERATOR      //   , 
                                //     
                                //   .
/*######################################################################*/
#include    "Windows.h"
#include    "stdio.h"
#include    "conio.h"

#include    "DllClient.h"
#include    "IADCUtility.h"
#include    "ADC_CONSTS.h"

#ifdef      SAVE_FILE
#include    "ALF.cpp"            
#endif
/*######################################################################*/
#define     NUMBER_OF_PACKETS   2000
#define     PAGE_SIZE           (100*4)
#define     FREQ_STREAM         60000.0
#define     SIN_SIZE            1024

#ifndef DIM
#define DIM(a)      (sizeof(a) / sizeof(a[0]))
#endif
/*######################################################################*/
//        .
//      .
int         Channels[3] = { 0, 1, 2 };
int         Gains[3]    = { 1, 1, 1 };
/*----------------------------------------------------------------------*/
//        .
short       Sin[] =
{
#include    "Sin1.txt"
#include    "Sin2.txt"
#include    "Sin3.txt"
};
/*======================================================================*/
void    WDac(IADCDevice* pADC, int ch, int val)
{
//  ((  {1, 2}) << 16) | short()
    int dac = (ch << 16) | (val & 0xFFFF);
    pADC->Get(ADC_WRITE_DAC, &dac);
}
/*----------------------------------------------------------------------*/
//       ,   
//    .     ,  
//        .

//  ...
int     main()
{
    IADCUtility* pUtil;
//    DEBUG
    int r = 0;

//     DLL   ADC 
    DllClient UClient;
    IFactory* pUFactory = (IFactory*)UClient.LoadRegistered(CompanyName,
                                                            ProductName,
                                                            VersionName,
                                                            "LABUtility");
    if(pUFactory == 0) 
    {
        printf("\n ERROR - LABUtility not found! \n");
        return 0;
    }

//      "IADCUtility"
    pUtil = (IADCUtility*)pUFactory->Create(_T("IADCUtility"), 0);
    if(pUtil == 0)
    {
        printf("\n ERROR - Object not created! \n");
        return 0;
    }

//    "EL100E"   "1"
//    ,      .
    if(pUtil->Setup("EL100E", 1, 0, PAGE_SIZE) <= 0)
    {
        printf("\n ERROR - Setup not ready! \n");
        return 0;
    }
//     . 16 ,  ,  +-32767
//     . -,    
//    .      12 
//    ,   16      .
//            32768  
//      . Volt = 10V / N;   
//    10,    +-1V.   . 
//            ( 16 )
//      0  .    
//     ,     , ,  
//      .       
//    .     ,
//           .
    pUtil->Get(ADCUTILITY_SET_CONVERT2INT16M, 0);
//          
//    0,       
    int blocks = 1024*1024;
    pUtil->Get(ADCUTILITY_SET_MAXIMUM_BLOCKS, &blocks);
    
//    "IADCDevice". DLL     
//  DLL ,   "IADCDevice".
    IADCDevice* pADC = 0;
    if(pUtil->Get(ADCUTILITY_GET_IADCDEVICE, &pADC) <= 0 || pADC == 0)
    {
        printf("\n ERROR - IADCDevice interface not found! \n");
        return 0;
    }
//           Get  
//   .
    pADC->AddRef();

//         1.0.
    float fRange = 0.0f;
    r = pADC->Get(ADC_GET_RANGE_BIPOLAR, &fRange);
    printf("\n Bipolar Range = %5.2f", double(fRange));
/*----------------------------------------------------------------------*/
//     
    unsigned serN = 0;
    r = pADC->Get(ADC_GET_SERIALNUMBER_LONG, &serN);
    printf("\n Serial Number = 0x%08X", serN);

#ifdef  FIRST_LOAD
//   32    .
//         .     .
//  ,      10000 - 20000 . 
//   ,     .
    unsigned user = 0x12345678;
    r = pADC->Get(ADC_WRITE_USER_DATA, &user);
    printf("\n User Data     = 0x%08X", user);
#endif

//    
//         .
    unsigned user0 = 0;
    r = pADC->Get(ADC_READ_USER_DATA, &user0);
    printf("\n User Data     = 0x%08X", user0);

//    
//    ,      .
    float temp = 0.0f;
    r = pADC->Get(ADC_GET_TEMP_SENSOR, &temp);
    printf("\n Temperature sensor = %4.2f", temp);

//   .      
//   .    .   
//       .     
//   .
    ADCParametersCALIBRATION pc;
    pc.m_nADC   = 5;
    pc.m_nDAC   = 0;
    pc.m_nExtra = 0;
    r = pADC->Init(ADC_INIT_MODE_CHECK, &pc, 0);
    if(r <= 0)
        printf("\n Calibration Read ERROR!");
    else
        printf("\n Calibration Read OK. Date: %02d:%02d:%4d", 
               pc.m_nExtra & 0xFF, (pc.m_nExtra >> 8) & 0xFF, pc.m_nExtra >> 16);
/*----------------------------------------------------------------------*/
//   . 
//      ,     .
//      ,    .
//         
//      SD  .     
//   .    SD      
//     .
    ADCParametersGENERATOR pg;

    printf("\n Stop Generator!");
    pg.m_nMode      = 0;
    pg.m_fFreq      = 0.0;
    pg.m_nAddress   = 0;
    pg.m_nAmplitude = 0;
    pg.m_nSize      = 0;
    pg.m_pData      = 0;
    r = pADC->Init(ADC_INIT_MODE_INIT, &pg, 0);
    printf(" %s.", r >= 0 ? "OK" : "Failed");

//       DAC1  DAC2
//       ,  .
//           
//    .      ,  
//     .
    printf("\n DAC0 & DAC1 Test ...");
    for(int i = -32768; i < 32767; i += 16)
    {
//       DAC (1)    -32768 (-10v)  +32767 (+10v)
        WDac(pADC, 1, i);
//       DAC (2)    -32768 (-10v)  +32767 (+10v)
        WDac(pADC, 2, i);
    }

//   0v
    WDac(pADC, 1, 0);
    WDac(pADC, 2, 0);

//   +10v
    WDac(pADC, 1,  32767);
    WDac(pADC, 2,  32767);

//   -10v
    WDac(pADC, 1, -32768);
    WDac(pADC, 2, -32768);

//   +5v
    WDac(pADC, 1,  16384);
    WDac(pADC, 2,  16384);

//   -5v
    WDac(pADC, 1, -16384);
    WDac(pADC, 2, -16384);

//    0v.
    WDac(pADC, 1, 0);
    WDac(pADC, 2, 0);
    printf(" OK.");

//        . 
//      .   
//     .     
//   .      
//      . 
//         50KHz.   
//       60KHz.     25KHz,  
//        100KHz.

#ifdef  FIRST_LOAD
//         - 256 .
//       .
//       256 .
//      6*1024 16-  .
//  DAC (1),   -32768 (-10v)  +32767 (+10v)
//    m_nAmplitude    1   ,
//    0   .
//   8   m_nMode    1    
//  DAC1,  2    .     
//      DAC1,      DAC2.
//      ,    
//  ,     ,   
//   .
//     .    ,    
//  ,   +32767  -32768  .    
//      +-10v.     
//   ,      .
//        
//  +-9.5v.
//     .  8K   5-6 .

//   3 a SIN  1024     
//   +-10v,      .
    printf("\n Load Generator +-10v! ...");
    pg.m_nMode      = 2;
    pg.m_fFreq      = 0.0;
    pg.m_nAddress   = 0;
    pg.m_nAmplitude = 1;
    pg.m_nSize      = DIM(Sin);
    pg.m_pData      = Sin;
    r = pADC->Init(ADC_INIT_MODE_INIT, &pg, 0);
    printf(" %s.", r > 0 ? "OK" : "Failed");

//   3 a SIN  1024     
//   +-5v
    for(i = 0; i < DIM(Sin); ++i)
        Sin[i] >>= 1;

    printf("\n Load Generator  +-5v! ...");
    pg.m_nMode      = 2;
    pg.m_fFreq      = 0.0;
    pg.m_nAddress   = DIM(Sin);
    pg.m_nAmplitude = 1;
    pg.m_nSize      = DIM(Sin);
    pg.m_pData      = Sin;
    r = pADC->Init(ADC_INIT_MODE_INIT, &pg, 0);
    printf(" %s.", r > 0 ? "OK" : "Failed");
#endif

//    0 +-10v
    printf("\n Start Generator 0 +-10v!");
    pg.m_nMode      = 2;
    pg.m_fFreq      = 25000.0;                      // 50000 max
    pg.m_nAddress   = SIN_SIZE * 0;
    pg.m_nAmplitude = 1;
    pg.m_nSize      = SIN_SIZE;
    pg.m_pData      = 0;
    r = pADC->Init(ADC_INIT_MODE_INIT, &pg, 0);
    printf(" %s.", r > 0 ? "OK" : "Failed");
    Sleep(3000);

#ifdef  MULTI_GENERATOR

//    1
    printf("\n Start Generator 1 +-10v!");
    pg.m_nMode      = 2;
    pg.m_fFreq      = 25000.0;                      // 50000 max
    pg.m_nAddress   = SIN_SIZE * 1;
    pg.m_nAmplitude = 1;
    pg.m_nSize      = SIN_SIZE;
    pg.m_pData      = 0;
    r = pADC->Init(ADC_INIT_MODE_INIT, &pg, 0);
    printf(" %s.", r > 0 ? "OK" : "Failed");
    Sleep(3000);

//    1
//     ,     .

    printf("\n Start Generator 1 +-5v!");
    pg.m_nMode      = 2;
    pg.m_fFreq      = 25000.0;                      // 50000 max
    pg.m_nAddress   = SIN_SIZE * (3+1);
    pg.m_nAmplitude = 1;
    pg.m_nSize      = SIN_SIZE;
    pg.m_pData      = 0;
    r = pADC->Init(ADC_INIT_MODE_INIT, &pg, 0);
    printf(" %s.", r > 0 ? "OK" : "Failed");
    Sleep(3000);

#endif

#ifdef  SAVE_GENERATOR

//    0 +-10v
//     ,    ,
//      .

    printf("\n Auto Start Generator 0 +-10v!");
    pg.m_nMode      = 2 | ADC_GENERATOR_MODE_AUTO_START;
    pg.m_fFreq      = 25000.0;                      // 50000 max
    pg.m_nAddress   = SIN_SIZE * 0;
    pg.m_nAmplitude = 1;
    pg.m_nSize      = SIN_SIZE;
    pg.m_pData      = 0;
    r = pADC->Init(ADC_INIT_MODE_INIT, &pg, 0);
    printf(" %s.", r > 0 ? "OK" : "Failed");

#endif

#ifdef  CLEAR_GENERATOR

//      .
//      ,     
//    .    
//    Flash     .

    printf("\n Auto Start Generator OFF!");
    pg.m_nMode      = 0xFF | ADC_GENERATOR_MODE_AUTO_START;
    pg.m_fFreq      = 0.0;
    pg.m_nAddress   = 0;
    pg.m_nAmplitude = 1;
    pg.m_nSize      = 0;
    pg.m_pData      = 0;
    r = pADC->Init(ADC_INIT_MODE_INIT, &pg, 0);
    printf(" %s.", r > 0 ? "OK" : "Failed");

#endif

#ifdef  STOP_GENERATOR

//   ,   .
//         .

    printf("\n Stop Generator!");
    pg.m_nMode      = 0;
    pg.m_fFreq      = 0.0;
    pg.m_nAddress   = 0;
    pg.m_nAmplitude = 0;
    pg.m_nSize      = 0;
    pg.m_pData      = 0;
    r = pADC->Init(ADC_INIT_MODE_INIT, &pg, 0);
    printf(" %s.", r >= 0 ? "OK" : "Failed");

#endif
/*----------------------------------------------------------------------*/
//     . 

//   .     .
//      .     
//   .
    pADC->PortIO(ADC_PORTIO_DISABLE, 0, 0);

//             
//     .    .
    short dg = 0x00;
    pADC->PortIO(ADC_PORTIO_OUTB, &dg, 1);
    dg = 0xFF;
    pADC->PortIO(ADC_PORTIO_OUTB, &dg, 1);
    dg = 0x55;
    pADC->PortIO(ADC_PORTIO_OUTB, &dg, 1);
    dg = 0xAA;
    pADC->PortIO(ADC_PORTIO_OUTB, &dg, 1);
    dg = 0;
    pADC->PortIO(ADC_PORTIO_OUTB, &dg, 1);
//   .     .
    pADC->PortIO(ADC_PORTIO_DISABLE, 0, 0);

//     .    . 
//       ,    
//             .
    pADC->PortIO(ADC_PORTIO_INB,  &dg, 1);
/*----------------------------------------------------------------------*/
//    .    
//  +-32767.     16    .
//  ,   13 .
//    ,      . 
//       .  
//         .  
//   ,  ...
    ADCParametersSAMPLE ps;
    ps.m_nControl = 0;
    ps.m_nGain    = 1;
    ps.m_nChannel = 0;
    ps.m_nValue   = 0;

//     100  .
    printf("\n Get 100 Samples =  ");
    for(i = 0; i < 100; ++i)
    {
        pADC->Init(0, &ps, 0); 
        printf(" %d", ps.m_nValue);
    }
    printf("\n OK.\n");
/*----------------------------------------------------------------------*/
#ifdef  SAVE_STREAM

//       .   
//        .

    HANDLE hFile = CreateALFFile("", 0);
    if(hFile == INVALID_HANDLE_VALUE) 
    {
        printf("\n ERROR - FILE not created! \n");
        pADC->Release();
        pUtil->Release();
        UClient.Free();
        return 0;
    }

    SaveALFHeader(hFile, fRange, DIM(Channels), Channels, Gains, FREQ_STREAM, 1);

//        .
//    
    ADCParametersBLOCK pb;
    pb.m_nStartOf     = ADCPARAM_START_TIMER;       //  ;

    pb.m_nBlockSize   = 0;                          //     ;
    pb.m_nMode        = ADC_BLOCK_MODE_MODECYCLE;   //
    pb.m_nControl     = 0;                          //     ;
    pb.m_nLevel       = 0;                          //     ;
    pb.m_fFreqStart   = FREQ_STREAM;                //   
    pb.m_fFreqPack    = 0.0;                        //     ;
    pb.m_nChannelSize = DIM(Gains);
    pb.m_pnGains      = Gains;
    pb.m_pnChannels   = Channels;

//   .       
//  .      .
    pUtil->Start(&pb, 0);
    printf("\n\n Start ADC stream...\n");

//        .   ,
//  ,  .   ,   .
//      ,    
//    .     .    
    for(int n = 0; n < NUMBER_OF_PACKETS;)
    {
//      .
//        
//   :
//  int blocks = 1024*1024;
//  pUtil->Get(ADCUTILITY_SET_MAXIMUM_BLOCKS, &blocks);
//         . 
//       .

        int run = 1;
        pUtil->Get(ADCUTILITY_STATUS_RUN, &run);
        if(run == 0)
            break;

        short* pData = 0;
        void* adr; unsigned mask;
        for(;;)
        {
//     .
//  adr -  . mask      .
//      ISA     .
            if(pUtil->GetBuffer(adr, mask) > 0)
            {
                pData = (short*)adr;
                printf("\r Save block N = %d", n);

                static DWORD dw; 
                ::WriteFile(hFile, pData, PAGE_SIZE * sizeof(short), &dw, 0);

//       .
//      ,   .  
//    ,      .
                pUtil->FreeBuffer();
                ++n;
                break;
            }
        }
    }

//   .
    pUtil->Stop();
    printf("\n Stop ADC.");

//   . !   ? 
    ::CloseHandle(hFile); 

#endif
/*----------------------------------------------------------------------*/
//    "IADCDevice".
    pADC->Release();
//    "IADCUtility".
    pUtil->Release();

//   DLLs.
    printf("\n And Release.\n");
    UClient.Free();
/*----------------------------------------------------------------------*/
//  ,   !    SD .
#ifdef  SAVE_FILE

    printf("\n Save File for SD card ...");

//    1,
//    , Chan[0], Gain[0]
//    1024 * 1024 * 5 ,
//   100KHz    
    r = SaveALFFile("", 1, fRange, 1, Channels, Gains, 1024*5, 100000.0);
    printf(" %s.\n", r > 0 ? "OK" : "Failed");

//      ,  50KHz.
    r = SaveALFFile("", 2, fRange, DIM(Channels), Channels, Gains, 1024*2, 50000.0);
    r = SaveALFFile("", 3, fRange, DIM(Channels), Channels, Gains, 1024*2, 50000.0);
    r = SaveALFFile("", 4, fRange, DIM(Channels), Channels, Gains, 1024*2, 50000.0);

#endif
/*----------------------------------------------------------------------*/
//  !    
    printf("\n Press any key for EXIT.");
    getch();
    return 0;
}
/*######################################################################*/
