// TestDAC.cpp : Defines the entry point for the console application.

//  Windows      EL100 ! 

#ifndef  DIM
#define  DIM(a)      (sizeof(a) / sizeof(a[0]))
#endif
#include    "include/DllClient.h"
#include    "include/IADCDevice.h"
IADCDevice* pADC;
ADCParametersBLOCK pb;
// ------------------------------------------------------------
void WDac( int ch, int val)
{
//  ((  {1, 2}) << 16) | short()
    int dac = (ch << 16) | (val & 0xFFFF);
    pADC->Get ( ADC_WRITE_DAC, &dac);
}
// ----------------------------------------------------------------------------
void setdac ( float volt ) 
{ 
   WDac(1, (int)( volt * 3276.8 ) );  //  DAC (1)    -32768 (-10v)  +32767 (+10v)
   WDac(2, (int)( volt * 3276.8 ) );
} 
// ------------------------------
#include "stdafx.h"

int main(int argc, char* argv[])
{
	DllClient DClient;  
	pADC = (IADCDevice*)DClient.LoadDriver ( "EL100E", "IADCDevice", 0);
    if(pADC == 0)
    {   
       printf ( "EL100E - Object not created!\n");  return FALSE;
    }
	if(pADC->Setup(1, 0, 0, 0) <= 0)
    {
        printf ( "EL100E - Setup not ready!\n");
        pADC->Release(); 
		return FALSE;
    }
	setdac ( 0 ); 
	
	for ( float f = 0; f < 10.0; f+= 0.01 ) setdac ( f ) , Sleep ( 20 ); //  0-10 - !

	setdac ( 0 ); 
	
	pADC->Stop();
	pADC->Release(); 
	return 0;
}

